/******************************************************
 * Architecture Module header file.                   *
 * This file is automatically generated by ArchC      *
 * WITHOUT WARRANTY OF ANY KIND, either express       *
 * or implied.                                        *
 * For more information on ArchC, please visit:       *
 * http://www.archc.org                               *
 *                                                    *
 * The ArchC Team                                     *
 * Computer Systems Laboratory (LSC)                  *
 * IC-UNICAMP                                         *
 * http://www.lsc.ic.unicamp.br                       *
 ******************************************************/
 

#ifndef  _MIPS1_H
#define  _MIPS1_H

#include "systemc.h"
#include "ac_module.H"
#include "ac_utils.H"
#include "mips1_parms.H"
#include "mips1_arch.H"
#include "mips1_isa.H"
#include "ac_tlm_intr_port.H"
#include "mips1_intr_handlers.H"


class mips1: public ac_module, public mips1_arch {
private:
  typedef cache_item<mips1_parms::AC_DEC_FIELD_NUMBER> cache_item_t;
  typedef ac_instr<mips1_parms::AC_DEC_FIELD_NUMBER> ac_instr_t;
public:

  unsigned bhv_pc;
 

  bool has_delayed_load;
  char* delayed_load_program;

  mips1_parms::mips1_isa ISA;
  mips1_inta_handler inta_hnd;
  ac_tlm_intr_port inta;

  unsigned id;

  bool start_up;
  unsigned* instr_dec;
  ac_instr_t* instr_vec;

  //!Behavior execution method.
  void behavior();

 
  SC_HAS_PROCESS( mips1 );

  //!Constructor.
  mips1( sc_module_name name_ ): ac_module(name_), mips1_arch(), ISA(*this), inta_hnd(*this), inta("inta", inta_hnd) {

    SC_THREAD( behavior );
    bhv_pc = 0; 
    has_delayed_load = false; 
    start_up=1;
    id = 1;

  }

  unsigned get_ac_pc();

  void set_ac_pc( unsigned int value );

  virtual void PrintStat();

  void init(int ac, char* av[]);

  void init();

  void load(char* program);

  void delayed_load(char* program);

  void stop(int status = 0);

  virtual ~mips1() {};

};
#endif  //_MIPS1_H

