#include <stdio.h>
#include "../shmacsim_microbenchmark.h"

#define REPEAT_COUNT 2000
#define REPEAT_COUNT_ASM ".rept 2000"

// override clock count retrieval def using clock tile
// remove these two lines to use the system register instead
//volatile unsigned int * clockTile = (volatile unsigned int *) 0x02000000;
//#define SHMAC_CLKCNT    (*clockTile)

ProcessorTask __processorTasks[SHMAC_MAX_GRIDDIM*SHMAC_MAX_GRIDDIM];
unsigned int __processorID;

// task function definitions
void printStartTime();

int main(int argc, char *argv[])
{	
    // initialization
    __processorID = SHMAC_PROCID;
    SHMAC_assignTasksToProcessors();
    // retrieve task for this processor
    ProcessorTask myTask = __processorTasks[__processorID];
    
    if(!myTask)
        printf("Processor %d was not assigned any tasks, exiting...\n", __processorID);   
    else
        myTask();
		
	return 0;
}

void printStartTime()
{
    // variables for time measurement
    unsigned int clkStart = 0;
    clkStart = SHMAC_CLKCNT;
    
    // print statistics
    printf("Processor %d: Start at: %d\n", __processorID, clkStart);
}


void SHMAC_assignTasksToProcessors()
{
    int i;
    // set all processor tasks to printStartTime
    for(i = 0; i < 16*16; i++)
        __processorTasks[i] = &printStartTime;
}


