// Header file with useful defines for writing SHMACsim microbenchmarks

// maximum dimension along a SHMACsim grid
#define SHMAC_MAX_GRIDDIM   16

// function pointer typedef for proc-task association
typedef void (*ProcessorTask)(void);
// 2D array of ProcessorTask's, one for each processor
extern ProcessorTask __processorTasks[SHMAC_MAX_GRIDDIM*SHMAC_MAX_GRIDDIM];
// local variable for local processor ID
extern unsigned int __processorID;


// system register addresses
volatile unsigned int * SHMAC_PROCID_REGISTER = (volatile unsigned int *) 0xFFFFFE03;
volatile unsigned int * SHMAC_CLKCNT_REGISTER = (volatile unsigned int *) 0xFFFFFDFF;
// macros to get system register values
#define SHMAC_PROCID    (*SHMAC_PROCID_REGISTER)
#define SHMAC_CLKCNT    (*SHMAC_CLKCNT_REGISTER)

// declaration for proc-task mapping function
void SHMAC_assignTasksToProcessors();
