/*
 * SHMACElement.cpp
 *
 * models the common functionality found in all SHMAC elements
 * (= routers, masters, slaves), mostly grid-related functions
 *
 *  Created on: 26 Feb 2013
 *      Author: Yaman Umuroglu
 */

#include "SHMACElement.h"
#include "shmac_simutils.h"

SHMACElement::SHMACElement(shmacsim::tile_coord coords)
{
	// coord setting only allowed at construction time
	m_coords = coords;
}

SHMACElement::SHMACElement(uint8_t i, uint8_t j)
{
	m_coords.i = i;
	m_coords.j = j;
}

shmacsim::tile_coord SHMACElement::getCoords() const
{
	return m_coords;
}

shmacsim::direction_enum SHMACElement::directionOfCoords(
		shmacsim::tile_coord foreignCoords)
{

	return shmacsim::directionOfCoords(m_coords, foreignCoords);
}

