/*
 * SHMACElement.h
 *
 * models the common functionality found in all SHMAC elements
 * (= routers, masters, slaves), mostly grid-related functions
 *
 *  Created on: 26 Feb 2013
 *      Author: Yaman Umuroglu
 */

#ifndef SHMACELEMENT_H_
#define SHMACELEMENT_H_

#include "shmac_types.h"

class SHMACElement {
public:
	SHMACElement(shmacsim::tile_coord coords);
	SHMACElement(uint8_t i, uint8_t j);

	// retrieve the element coords in the SHMAC grid
	shmacsim::tile_coord getCoords() const;
	shmacsim::direction_enum directionOfCoords(shmacsim::tile_coord foreignCoords);

protected:
	shmacsim::tile_coord m_coords;
};

#endif /* SHMACELEMENT_H_ */
