/*
 * SHMACPacketTracker.h
 *
 *  Created on: Jun 19, 2013
 *      Author: maltanar
 */

#ifndef SHMACPACKETTRACKER_H_
#define SHMACPACKETTRACKER_H_

#include "shmac_types.h"
#include <systemc.h>

class SHMACPacketTracker
{
public:
	SHMACPacketTracker();
	virtual ~SHMACPacketTracker();

	// check if this packet is to be tracked, create tracker if
	// it is to be tracked. remember to delete tracker when done!
	static void tracePacket(shmacsim::packet *pkt, std::string loc);

	// attach this tracker to given packet
	void startTracking(shmacsim::packet *pkt, std::string initialLocation);
	// register location for currently tracked packet at current time
	void registerLocation(std::string locationName);
	// stop tracking packet and print out info
	void terminateTracking();


protected:
	// structure for tracking information
	typedef struct _PacketTrackingEntry {
		std::string locationName;
		sc_time start;
		sc_time end;
		_PacketTrackingEntry * nextEntry;
	} PacketTrackingEntry;

	bool m_trackingActive;
	shmacsim::packet m_trackedPacket;
	PacketTrackingEntry * m_entryChainHead, * m_entryChainTail;
};

#endif /* SHMACPACKETTRACKER_H_ */
