#ifndef SHMAC_TYPEUTILS_H_
#define SHMAC_TYPEUTILS_H_

#include "shmac_types.h"

using namespace shmacsim;

// TODO make other useful zero or empty initialized const vars

// empty / dummy router packet
const packet dummyPacket = { false, shmacsim::PACKET_WREN_READ4,
		shmacsim::PACKET_FLAG_NONE, { 0, 0 }, 0, 0, NULL };

const direction_stdlogic_vector emptyDirectionLogicVector = "000000";

// human-readable names for directions
extern std::string __directionNames[];
#define		getDirectionName(x)		(__directionNames[x])
// "inverse" of a direction, to pass the origin parameter in receiveMessage wrt pkt destination
extern direction_enum __directionInverse[];
#define		getDirectionInverse(x)	(__directionInverse[x])

// macro for iterating something over each SHMAC direction
#define SHMAC_FOREACH_DIR(x)	for(int x = 0; x < SHMAC_DIRECTION_COUNT; x++)

// make a SHMAC request packet with given params
packet makeRequestPacket(tile_coord sender, bus32 address, packet_flag sync =
		shmacsim::PACKET_FLAG_NONE, packet_wren wren =
		shmacsim::PACKET_WREN_READ4);
// convenience function for turning set of ints into tile_coord
tile_coord makeTileCoord(int i, int j);
// convenience function for getting the coordinate of the tile the addr belongs to
tile_coord getTileCoordFromAddress(bus32 address);
// conveniece function for getting the local address part of a given SHMAC address
bus32 getLocalAddressFromAddress(bus32 address);
// convenience function to set local part of global SHMAC address
bus32 setAddressLocalAddress(bus32 oldAddress, bus32 newLocalAddress);
// convenience function to set coordinate part of global SHMAC address
bus32 setAddressTileCoord(bus32 oldAddress, tile_coord coord);

#endif /* SHMAC_TYPEUTILS_H_ */
