/*
 * SHMACMasterArchCMIPS1.h
 *
 *  Created on: 6 Mar 2013
 *      Author: Yaman Umuroglu
 */

#ifndef SHMACMASTERARCHCMIPS1_H_
#define SHMACMASTERARCHCMIPS1_H_

#include <SHMACMaster.h>
#include "SHMACTLMAdapter.h"
#include "mips1.H"
#include "SHMACSysRegFile.h"
#include <wordexp.h> // for cmdline parsing

class SHMACMaster_ArchC_MIPS1: public SHMACMaster
{
public:
	SHMACMaster_ArchC_MIPS1(sc_module_name name, SHMACElement * parent = NULL);
	~SHMACMaster_ArchC_MIPS1();

	void setParent(SHMACElement * parent);
	mips1 * getProcessorCore() const
	{
		return m_proc;
	}

	void prepare(uint32_t heap_ptr, std::string cmdLine, bool integratedBootstrap);

protected:
	SHMACTLMAdapter * m_tlmAdapter;
	SHMACSysRegFile * m_sysRegFile;
	mips1 * m_proc;
	wordexp_t m_wordexp;

};

#endif /* SHMACMASTERARCHCMIPS1_H_ */
