/*
 * SHMACSysRegFileWithRAMPort.h
 *
 *  Created on: Jul 3, 2013
 *      Author: maltanar
 */

#ifndef SHMACROUTERBYPASS_H_
#define SHMACROUTERBYPASS_H_

#include "shmac_interfaces.h"
#include "shmac_types.h"
#include <systemc.h>

class SHMACRouterBypass : public SHMACMemoryInterface, public sc_module
{
	SC_HAS_PROCESS(SHMACRouterBypass);
public:
	SHMACRouterBypass(sc_module_name name);
	virtual ~SHMACRouterBypass();

	sc_port<SHMACMemoryInterface> toRAMPort, toMasterPort, toRouterPort, fromRouterPort;

	virtual void receiveMessage(shmacsim::packet message);
	void setLocalMemRange(SHMAC_ADDR start, SHMAC_ADDR end);

protected:
	uint32_t m_localMemStart, m_localMemEnd;
	bool m_bypassEnabled;

	void sendBypassMessages();
	sc_fifo<shmacsim::packet> * m_bypassBuffer;
};

#endif /* SHMACROUTERBYPASS_H_ */
