/*
 * SHMACTrafficTester.h
 *
 *  Created on: Jun 13, 2013
 *      Author: maltanar
 */

#ifndef SHMACTRAFFICTESTER_H_
#define SHMACTRAFFICTESTER_H_

#include <systemc.h>
#include "SHMACMaster.h"
#include "shmac_interfaces.h"
#include "shmac_types.h"

class SHMACTrafficTester : public SHMACMaster, public SHMACMemoryInterface
{
	SC_HAS_PROCESS(SHMACTrafficTester);

public:
	SHMACTrafficTester(sc_module_name name, SHMACElement * parent = NULL);
	virtual ~SHMACTrafficTester();

	void setSendPacket(shmacsim::packet pkt);
	void setSendDelay(sc_time delay);
	void setSendPacketCount(uint32_t cnt);

	void generateTraffic();

	// implemented from SHMACMemoryInterface
	void receiveMessage(shmacsim::packet message);

protected:
	// member variables and functions relating to packet generation
	shmacsim::packet m_packetToSend;
	sc_time m_delaySend;
	uint32_t m_sendPacketCount;


	// member variables and functions relating to packet reception and statistics
	typedef struct
	{
		shmacsim::packet packet;
		uint32_t packetCount;
		//sc_time lastReceived;
		// sc_time averageInterArrival;
		//sc_time maxInterArrival;
	} trafficLog;

	uint32_t m_receivedPacketCount;
	std::vector<trafficLog> m_logEntries;
	void periodicReport();
	void reportStats();
};

#endif /* SHMACTRAFFICTESTER_H_ */
