/*
 * SHMACMemToRTLAdapter.cpp
 *
 *  Created on: Jun 4, 2013
 *      Author: maltanar
 */

#include "SHMACMemToRTLAdapter.h"
#include "shmac_typeutils.h"
#include "SHMACPacketTracker.h"

SHMACMemToRTLAdapter::SHMACMemToRTLAdapter(sc_module_name name) :
		sc_module(name)
{
}

SHMACMemToRTLAdapter::~SHMACMemToRTLAdapter()
{
}

void SHMACMemToRTLAdapter::receiveMessage(shmacsim::packet message)
{
	// annotate timing info if desired
	if (message.tag)
		((SHMACPacketTracker *) message.tag)->registerLocation("MemToRTL");

	// wait until tx line becomes available
	if (tx_ack == true)
		wait(tx_ack.negedge_event());
	// put received data onto tx line
	tx_data = message;
	// set request high
	tx_req = true;
	// wait until acknowledged
	wait(tx_ack.posedge_event());
	// remove data and request
	tx_data = dummyPacket;
	tx_req = false;
	// optional: wait until line is free again
	wait(tx_ack.negedge_event());
}
