/*
 * SHMACRTLToMemAdapter.cpp
 *
 *  Created on: Jun 4, 2013
 *      Author: maltanar
 */

#include "SHMACRTLToMemAdapter.h"
#include "SHMACPacketTracker.h"

SHMACRTLToMemAdapter::SHMACRTLToMemAdapter(sc_module_name name) :
		sc_module(name)
{
	SC_THREAD(sendRequests);
}

SHMACRTLToMemAdapter::~SHMACRTLToMemAdapter()
{
}

void SHMACRTLToMemAdapter::sendRequests()
{
	shmacsim::packet readData;
	while(1)
	{
		// wait for incoming request
		if(rx_req.read() == false)
			wait(rx_req.posedge_event());
		// read out data
		readData = rx_data.read();
		// annotate timing info if desired
		if (readData.tag)
			((SHMACPacketTracker *) readData.tag)->registerLocation("RTLToMem");
		// send ACK to allow sender to continue
		rx_ack.write(true);
		// send out read data via SHMACMemIF
		txPort->receiveMessage(readData);
		// wait until request is no longer active
		if(rx_req.read() == true)
			wait(rx_req.negedge_event());
		// remove ACK
		rx_ack.write(false);
	}
}
