#ifndef SHMACROUTERARBITER_H_
#define SHMACROUTERARBITER_H_

#include <systemc.h>
#include "shmac_types.h"

// submodule includes and forward class declarations
// TODO

class SHMACRouterArbiter : public sc_module {
public:
	SC_HAS_PROCESS(SHMACRouterArbiter);

	sc_in<bool> enable;
	sc_in<bool> req_i[SHMAC_DIRECTION_COUNT];
	sc_out<uint8_t> grant_o; // TODO should eventually be shmacsim::direction_enum, but enums seme to always take 32 bits..
	sc_out<bool> valid;
	sc_in_clk clk;

	SHMACRouterArbiter(sc_module_name instanceName);

	void behaviour();
	void pickWinners();
	void convertReqGrantSignals();

protected:
	sc_signal<shmacsim::direction_stdlogic_vector> grant_q;
	sc_signal<shmacsim::direction_stdlogic_vector> pre_req;
	sc_signal<shmacsim::direction_stdlogic_vector> sel_gnt;
	sc_signal<shmacsim::direction_stdlogic_vector> isol_lsb;
	sc_signal<shmacsim::direction_stdlogic_vector> mask_pre;
	sc_signal<shmacsim::direction_stdlogic_vector> win;

	sc_signal<shmacsim::direction_stdlogic_vector> req;
};

#endif /* SHMACROUTERARBITER_H_ */
