#include "SHMACRouterCrossbar.h"
#include "shmac_simutils.h"
#include "shmac_typeutils.h"
#include "SHMACPacketTracker.h"

SHMACRouterCrossbar::SHMACRouterCrossbar(sc_module_name name)
{
	SC_METHOD(switching);

	SHMAC_FOREACH_DIR(shmacDir)
	{
		sensitive << tx_ack[shmacDir] << rx_data[shmacDir];
		SHMAC_FOREACH_DIR(shmacDir2)
			sensitive << arb_grant[shmacDir][shmacDir2];
	}
}

void SHMACRouterCrossbar::switching()
{
	// write default values
	SHMAC_FOREACH_DIR(shmacDir)
	{
		tx_data[shmacDir] = dummyPacket;
		rx_ack[shmacDir] = false;
	}

	// iterate over each possible src-dest link and connect together
	// the relevant src-dest data and ack ports if enabled
	SHMAC_FOREACH_DIR(dataDestDir)
		SHMAC_FOREACH_DIR(dataSrcDir)
		{
			if (arb_grant[dataSrcDir][dataDestDir].read() == true)
			{
				tx_data[dataDestDir] = rx_data[dataSrcDir].read();
				// annotate timing if desired
				/*if (rx_data[dataSrcDir].read().tag)
					((SHMACPacketTracker *) rx_data[dataSrcDir].read().tag)->registerLocation(
							"routerX");*/

				rx_ack[dataSrcDir] = tx_ack[dataDestDir].read();
			}
		}
}
