#ifndef SHMACROUTERINPUTPORT_H_
#define SHMACROUTERINPUTPORT_H_

#include <systemc.h>
#include "shmac_simutils.h"
#include "shmac_types.h"

class SHMACRouterInputPort: public sc_module
{
public:
	SC_HAS_PROCESS(SHMACRouterInputPort);

	sc_in_clk clk;

	sc_in<bool> rx_req;
	sc_in<shmacsim::packet> rx_data;
	sc_out<bool> rx_ack;

	sc_in<bool> input_router_ack;
	sc_out<bool> input_router_req[SHMAC_DIRECTION_COUNT];
	sc_out<shmacsim::packet> input_router_packet;

	SHMACRouterInputPort(sc_module_name name, shmacsim::tile_coord coord);

	void setCoords(shmacsim::tile_coord coord) {m_localCoord = coord;};

	void findRoutingDir();
	void fsm();
	void sync_proc();

protected:
	typedef enum {
		idle,
		route,
		handshake,
		handshake2
	} InputPortState;

	shmacsim::tile_coord m_localCoord;

	sc_signal<InputPortState> state, next_state;
	sc_signal<shmacsim::direction_enum> routing_direction;
	sc_signal<bool> rx_ack_i;
	sc_signal<bool> input_router_req_i[SHMAC_DIRECTION_COUNT];
	sc_signal<shmacsim::packet> input_router_packet_i;
	sc_signal<shmacsim::packet> input_router_packet_r;

};


#endif /* SHMACROUTERINPUTPORT_H_ */
