const char *project_name = "mips1";
const char *project_file = "mips1.ac";
const char *archc_version = "2.1";
const char *archc_options = "-abi ";

#include  <iostream>
#include  <systemc.h>
#include  "ac_stats_base.H"
#include  "mips1.H"
#include "shmac_typeutils.h"
#include <time.h>
#include <getopt.h>

#include "SHMACSlave.h"
#include "SHMACPrintSlave.h"
#include "SHMACLockSlave.h"
#include "SHMACTLMAdapter.h"
#include "SHMACRouter.h"
#include "SHMACTile.h"
#include "SHMACMasterArchCMIPS1.h"
#include "SHMACLibrary.h"

#include "SHMACGrid.h"

#include "shmac_simutils.h"

#include "UnitTest_SHMACRouterArbiter.h"
#include "UnitTest_SHMACRouterInputPort.h"
#include "UnitTest_SHMACRouterOutputPort.h"
#include "UnitTest_SHMACRouterCrossbar.h"
#include "UnitTest_SHMACRouterCycAcc.h"

using std::cout;
using std::endl;

#include "SHMACTrafficTester.h"

int sc_main(int argc, char *argv[])
{
	/*SHMACElement p(1,1);
	SHMACRouterCycAcc router("r", &p);
	sc_clock clk("clk", SHMAC_CLOCK_PERIOD_NS, SC_NS, 0.5);
	SHMACTrafficTester   * tst[SHMAC_DIRECTION_COUNT];
	char nameBuffer[20];

	shmacsim::packet testPacket;
	testPacket.address = 0x11000000;
	testPacket.sender =	{1,1};
	testPacket.req = true;
	testPacket.data = 0;


	SHMAC_FOREACH_DIR(dir)
	{
		sprintf(nameBuffer, "%s_tst", getDirectionName(dir).c_str());
		tst[dir] = new SHMACTrafficTester(nameBuffer);
		router.connectSHMACMemInterface((shmacsim::direction_enum) dir, tst[dir]->inboundMemoryPort, tst[dir]->outboundMemoryPort);
		// customize test packet for this direction
		testPacket.data = dir;
		tst[dir]->setSendPacketCount(100);
		tst[dir]->setSendPacket(testPacket);
		tst[dir]->setSendDelay(shmacsim::getClockCycles(5));
	}

	router.clk(clk);

	sc_start(3000, SC_NS);

	return 0;*/

	static struct option long_options[] = {
	        {"hardware", 1, 0, 'h'},
	        {"runtime", 1, 0, 'r'},
	        {NULL, 0, NULL, 0}
	    };

	char * hwConfig, * rtConfig;
	int c;

	// TODO check runtime arg correctness
	while((c = getopt_long(argc, argv, "h:r:", long_options, NULL)) != -1)
	{
		switch(c)
		{
		case 'h':
			hwConfig = optarg;
			break;
		case 'r':
			rtConfig = optarg;
			break;
		}
	}

	cerr << "SHMACsim is now starting..." << endl << endl;
	cerr << "Configured clock period: \t " << getClockCycles(1) << endl;
	cerr << "Hardware configuration file:\t" << hwConfig << endl;
	cerr << "Runtime configuration file:\t" << rtConfig << endl;

	SHMACGrid * gr;

	// instantiate the grid described in the grid config file
	gr = shmacsim::createGridFromConfigFile(hwConfig);

	// load the desired application onto the desired tiles and perform runtime cfg
	shmacsim::configureGridFromConfigFile(rtConfig, gr);

	// call the runtime initializers, if any
	gr->callRuntimeInitializers();

	timespec tp, tp2;

	clock_gettime(0, &tp);
	sc_start();
	clock_gettime(0, &tp2);

	cerr << std::endl << "Simulation finished, elapsed SC time: "
			<< sc_time_stamp() << " wall time: "
			<< difftime(tp2.tv_sec, tp.tv_sec) << " s" << std::endl;

	delete gr;

	return 0;
}
