/*
 * SHMACDualPortRAM.h
 *
 *  Created on: Jul 3, 2013
 *      Author: maltanar
 */

#ifndef SHMACDUALPORTRAM_H_
#define SHMACDUALPORTRAM_H_

#include "SHMACSlave.h"
#include "SHMACSlavePort.h"

// FIXME needs a total rewrite -
// all these are part of a bad hack to implement dual-port memory

class SHMACDualPortRAM : public SHMACSlave
{
public:
	SC_HAS_PROCESS(SHMACDualPortRAM);

	sc_port<SHMACMemoryInterface, 1, SC_ZERO_OR_MORE_BOUND> secondaryInboundPort, secondaryOutboundPort;

	SHMACDualPortRAM(sc_module_name name, uint32_t memsize_bytes, SHMACElement * parent = NULL, bool readOnly = false);
	virtual ~SHMACDualPortRAM();

	// slave accessors overridden to include the second port
	virtual sc_mutex * getMemMutex(int portNumber)
	{
		return (portNumber == 0 ? &m_memLock : &m_memLock_port2);
	}
	;
	virtual sc_event * getRequestEvent(int portNumber)
	{
		return (portNumber == 0 ? &m_pendingRequest : &m_pendingRequest_port2);
	}
	;
	virtual sc_event * getServedEvent(int portNumber)
	{
		return (portNumber == 0 ? &m_requestServed : &m_requestServed_port2);
	}
	;
	virtual shmacsim::packet * getPacketBuffer(int portNumber)
	{
		return (portNumber == 0 ? &m_receivedMessage : &m_receivedMessage_port2);
	}
	;

	virtual uint32_t getPortCount() {return 2;};

protected:
	SHMACSlavePort * m_secondaryPort;

	shmacsim::packet m_receivedMessage_port2;
	sc_event m_pendingRequest_port2, m_requestServed_port2;
	sc_mutex m_memLock_port2;
	virtual void performMemoryAccesses_port2();
	void handleMessage_port2(shmacsim::packet message);
};

#endif /* SHMACDUALPORTRAM_H_ */
