/*
 * SHMACJumpSlave.h
 *
 *  Created on: Jun 18, 2013
 *      Author: maltanar
 *
 *      Models the behaviour of a jump slave
 */

#ifndef SHMACJUMPSLAVE_H_
#define SHMACJUMPSLAVE_H_

#include "SHMACSlave.h"


#define SHMAC_JUMPSLAVE_ADDR_LUI	0x0
#define	SHMAC_JUMPSLAVE_ADDR_ORI	0x4
#define	SHMAC_JUMPSLAVE_ADDR_JR		0x8
#define	SHMAC_JUMPSLAVE_ADDR_NOP	0xC

class SHMACJumpSlave: public SHMACSlave
{
public:
	SHMACJumpSlave(sc_module_name name, SHMACElement * parent = NULL);
	virtual ~SHMACJumpSlave();

protected:
	// virtual methods for memory access - reimplemented for jump slave
	virtual void memorySetWord(SHMAC_ADDR address, SHMAC_WORD data);
	virtual SHMAC_WORD memoryGetWord(SHMAC_ADDR address);
};

#endif /* SHMACJUMPSLAVE_H_ */
