#!/bin/sh

if [ "$#" -lt "3" ]; then
  echo "Compiles a given source file for all tiles in SHMACsim"
  echo "Usage: shmacsim-archc-allcompile i_dim j_dim gcc_args"
  exit 0
fi

SHMACSIM_TOOLS_DIR=$SHMACSIM_ROOT/tools
SHMACSIM_COMPILE_SCRIPT_NAME=shmacsim-archc-compile.sh
SHMACSIM_COMPILE_SCRIPT=$SHMACSIM_TOOLS_DIR/$SHMACSIM_COMPILE_SCRIPT_NAME

# since tile indices start from 0, subtract 1 from max vals
I_DIM=`expr $1 - 1`
J_DIM=`expr $2 - 1`

# shift out first two parameters, rest will be passed to gcc
shift 2

# call SHMACsim compile script for each tile
for i in `seq 0 $I_DIM`
do
	for j in `seq 0 $J_DIM`
	do
    	$SHMACSIM_COMPILE_SCRIPT $i $j $@
	done
done

echo "\n\nshmacsim-allcompile finished. Runtime config file suggestion:\n"

# print out runtime config file mapping tiles to produced executables
for i in `seq 0 $I_DIM`
do
	for j in `seq 0 $J_DIM`
	do
    	echo "($i,$j)\tsLoadBinary\t$PWD/($i,$j).bin"
	done
done
